<template>
    <section>
            <Notificacao 
                v-if="getState.notificacao.show"
                class="notificacao"
            />
            <div class="card-container">
                <div v-for="(produto, indice) in state.produtos" :key="indice" class="card-content">
                    <CompontenteCard 
                        :produto="produto" 
                        :adicionarItensCarrinho="adicionarItensCarrinho"
                        class="card" />
                </div>
            </div>
    </section>
</template>

<script>
import { getState, setItensCarrinho } from '@/store'
import { reactive } from '@vue/reactivity'
import { onMounted, watch } from '@vue/runtime-core'
import CompontenteCard from '../modules/bulma/Card'
import { requestGET } from '../../services/http/index'
import Notificacao from '../modules/bulma/Notificacao.vue'

export default {
    components: {
        CompontenteCard,
        Notificacao
    },
    setup() {
        const state = reactive({
            produtos: []
        })

        const adicionarItensCarrinho = (produto) => {
            setItensCarrinho(produto)
        }

        watch(
            () => getState.resultadoPesquisaProduto,
            (resultadoPesquisaProduto) => {

                state.produtos = getState.produtos.filter(produto => {
                    return produto.nome.toLowerCase().indexOf(resultadoPesquisaProduto.toLowerCase()) >= 0
                })

            }
        )
        
        onMounted(() => {
            getProdutos()
        })
        
        const getProdutos = () => {
            return requestGET('http://localhost:8000/api/produto').then(response => {
                return state.produtos = response.data
            })            
        }

        return {
            getState,
            state,
            adicionarItensCarrinho,
            setItensCarrinho,
            getProdutos
        }

    }
}
</script>

<style scoped>
    section {
        max-width: 51em;
        margin: auto;
    }
    .card-container {
        display: flex;
        flex-wrap: wrap;
        justify-content: center;
    }
    .card-content {
        margin: -8px;
    }
    .notificacao {
        position: sticky;
        top: 5em;
        z-index: 2;
        text-align: center;
    }
    
</style>